
class LetExpression implements Expression
{
    private String id;
    private Expression expr;
    private Expression body;

    public LetExpression(String id, Expression expr, Expression body)
    {
	this.id = id;
	this.expr = expr;
	this.body = body;
    }

    public int evaluate(Context c)
    {
	c.push(id, expr.evaluate(c));
	int res = body.evaluate(c);
	c.remove(id);
	return res;
    }

    public String toString()
    {
	return "let " + id + " = " + expr.toString() + " in " + body.toString();
    }
}
